
#include "OLED_Font.h"
#include "stdio.h"
#include "stdarg.h"
#include "OLED.h"
#include "mymode.h"

//--------------------- spi7脚oled ---------------------
// 端口定义: 7针排列..
//   1.GND ------- 地线
//   2.VCC ------- 电源 3.3-5V
//   3.SCK --  时钟端
//   4.SDA --  数据端 (MOSI)
//   5.RES --  复位端
//   6.DC  --  数据/命令切换
//   7.CS  --  片选端

//延时
void delay_oled()
{
//	int t_oled=100;
//	while(t_oled--);
}
//7片选  0有效
void spi_oled_cs(bit x)
{
	MySPI_W_SS(x);
}
//3
void spi_oled_CLK(bit x)
{
	MySPI_W_SCK(x);
}
void spi_oled_send(char dat)
{
	u8 i;
	for (i = 0; i < 8; i ++)
	{
		MySPI_W_MOSI(dat & (0x80 >> i));
		spi_oled_CLK(1);
		spi_oled_CLK(0);
	}
	//MySPI_SwapByte(dat);
}
//6
void spi_oled_cmdordata(bit cor)//1数据，0命令
{
	MySPI_W_MISO(cor);
}

//--------------------- spi7脚oled ---------------------


//使用自己的IIC通信总线
/*引脚初始化*/
void OLED_I2C_Init(void)
{
	
}

/**
  * @brief  I2C开始
  * @param  无
  * @retval 无
  */
void OLED_I2C_Start(void)
{
	
}

/**
  * @brief  I2C停止
  * @param  无
  * @retval 无
  */
void OLED_I2C_Stop(void)
{
	
}

/**
  * @brief  I2C发送一个字节
  * @param  Byte 要发送的一个字节
  * @retval 无
  */
void OLED_I2C_SendByte(unsigned char Byte)
{
	Byte=0;
}

/**
  * @brief  OLED写命令
  * @param  Command 要写入的命令
  * @retval 无
  */
void OLED_WriteCommand(unsigned char Command)
{
	//软件spi接口
	spi_oled_cmdordata(0);
	spi_oled_cs(0);
	spi_oled_send(Command);
	spi_oled_cmdordata(1);
	spi_oled_cs(1);
	
//	spi_oled_CLK(1);
//	MySPI_W_SDA(1);
	
	//硬件iic接口
//	I2C_WriteNbyte(0x78,0x00,&Command,1);
	
	//软件iic接口
//	OLED_I2C_Start();
//	OLED_I2C_SendByte(0x78);		//从机地址
//	MyI2C_ReceiveAck();
//	OLED_I2C_SendByte(0x00);		//写命令
//	MyI2C_ReceiveAck();
//	OLED_I2C_SendByte(Command);
//	MyI2C_ReceiveAck();
	
	
	//OLED_I2C_Stop();
	
	//myIIC_Write(0x78,0,Command);
}

/**
  * @brief  OLED写数据
  * @param  Data 要写入的数据
  * @retval 无
  */
void OLED_WriteData(unsigned char Data)
{
	//软件spi接口
	spi_oled_cmdordata(1);
	spi_oled_cs(0);
	spi_oled_send(Data);
	spi_oled_cs(1);
	
//	spi_oled_CLK(1);
//	MySPI_W_SDA(1);
	//硬件iic接口
//	I2C_WriteNbyte(0x78,0x40,&Data,1);
	
	
//	OLED_I2C_Start();
//	OLED_I2C_SendByte(0x78);		//从机地址
//	MyI2C_ReceiveAck();
//	OLED_I2C_SendByte(0x40);		//写数据
//	MyI2C_ReceiveAck();
//	OLED_I2C_SendByte(Data);
//	MyI2C_ReceiveAck();
	
	
	//OLED_I2C_Stop();
	
	//myIIC_Write(0x78,0,Command);
}

/**
  * @brief  OLED设置光标位置
  * @param  Y 以左上角为原点，向下方向的坐标，范围：0~7
  * @param  X 以左上角为原点，向右方向的坐标，范围：0~127
  * @retval 无
  */
void OLED_SetCursor(short Y, short X)
{
	OLED_WriteCommand(0xB0 | Y);					//设置Y位置
	OLED_WriteCommand(0x10 | ((X & 0xF0) >> 4));	//设置X位置低4位
	OLED_WriteCommand( X & 0x0F);			//设置X位置高4位
}

/**
  * @brief  OLED清屏
  * @param  无
  * @retval 无
  */
void OLED_Clear(void)
{  
	unsigned char i, j;
	for (j = 0; j < 8; j++)
	{
		OLED_SetCursor(j, 0);
		for(i = 0; i < 128; i++)//左到右
		{
			OLED_WriteData(0x00);//上到下
		}
	}
}

/**
  * @brief  OLED显示一个字符
  * @param  Line 行位置，范围：1~4
  * @param  Column 列位置，范围：1~16
  * @param  Char 要显示的一个字符，范围：ASCII可见字符
  * @retval 无
  */
void OLED_ShowChar(short Line, short Column, short Char)
{
	unsigned char i;
	OLED_SetCursor((Line - 1) * 2, (Column - 1) * 8);		//设置光标位置在上半部分
	for (i = 0; i < 8; i++)
	{
		OLED_WriteData(OLED_F8x16[Char - ' '][i]);			//显示上半部分内容
	}
	OLED_SetCursor((Line - 1) * 2 + 1, (Column - 1) * 8);	//设置光标位置在下半部分
	for (i = 0; i < 8; i++)
	{
		OLED_WriteData(OLED_F8x16[Char - ' '][i + 8]);		//显示下半部分内容
	}
}
void Char_mini(short x,short y,short chr)
{
    unsigned char c=0,i=0;
    c=chr-' ';
	OLED_SetCursor(x,y);
	for(i=0;i<6;i++)
	OLED_WriteData(F6x8[c][i]);
}

void Char_mini_black(short x,short y,short chr)
{
    unsigned char c=0,i=0;
    c=chr-' ';
	OLED_SetCursor(x,y);
	for(i=0;i<6;i++)
	OLED_WriteData(~F6x8[c][i]);
}

/**
  * @brief  OLED显示字符串
  * @param  Line 起始行位置，范围：1~4
  * @param  Column 起始列位置，范围：1~16
  * @param  String 要显示的字符串，范围：ASCII可见字符
  * @retval 无
  */
void OLED_ShowString(unsigned char Line, unsigned char Column, char *String)
{
	unsigned char i;
	for (i = 0; String[i] != '\0'; i++)
	{
		OLED_ShowChar(Line, Column + i, String[i]);
	}
}
void OLED_ShowString_mini(short Line, short Column, char *String)
{
	unsigned char i;
	for (i = 0; String[i] != '\0'; i++)
	{
		Char_mini(Line-1, Column-1 + i*6, String[i]);
	}
}

void OLED_ShowString_mini_black(short Line, short Column, char *String)
{
	unsigned char i;
	for (i = 0; String[i] != '\0'; i++)
	{
		Char_mini_black(Line-1, Column-1 + i*6, String[i]);
	}
}

/**
  * @brief  OLED次方函数
  * @retval 返回值等于X的Y次方
  */
unsigned long OLED_Pow(unsigned long X, long Y)
{
	unsigned long Result = 1;
	while (Y--)
	{
		Result *= X;
	}
	return Result;
}
void printf_oled(char a,char b,char *stringg, ...)//格式化发送
{
	char stringx[100];  //一个足够长的字符串
	va_list arg;
	va_start(arg,stringg);
	vsprintf(stringx,stringg,arg);
	va_end(arg);
	OLED_ShowString(a,b,stringx); //发送函数 可以是oled usart spi 。。。。字符串格式
}
void printf_oled_mini(char a,char b,char *stringg, ...)//格式化发送
{
	char stringx[100];  //一个足够长的字符串
	va_list arg;
	va_start(arg,stringg);
	vsprintf(stringx,stringg,arg);
	va_end(arg);
	OLED_ShowString_mini(a,b,stringx); //发送函数 可以是oled usart spi 。。。。字符串格式
}

void printf_oled_mini_black(char a,char b,char *stringg, ...)//格式化发送
{
	char stringx[100];  //一个足够长的字符串
	va_list arg;
	va_start(arg,stringg);
	vsprintf(stringx,stringg,arg);
	va_end(arg);
	OLED_ShowString_mini_black(a,b,stringx); //发送函数 可以是oled usart spi 。。。。字符串格式
}

/**
  * @brief  OLED初始化
  * @param  无
  * @retval 无
  */
void OLED_Init(void)
{
	unsigned long i, j;
	
	for (i = 0; i < 1000; i++)			//上电延时
	{
		for (j = 0; j < 1000; j++);
	}
	OLED_I2C_Start();
//	OLED_I2C_Init();			//端口初始化
	
	OLED_WriteCommand(0xAE);	//关闭显示
	
	OLED_WriteCommand(0xD5);	//设置显示时钟分频比/振荡器频率
	OLED_WriteCommand(0x80);
	
	OLED_WriteCommand(0xA8);	//设置多路复用率
	OLED_WriteCommand(0x3F);
	
	OLED_WriteCommand(0xD3);	//设置显示偏移
	OLED_WriteCommand(0x00);
	
	OLED_WriteCommand(0x40);	//设置显示开始行
	
	//双双反置可以将屏幕反转
	OLED_WriteCommand(0xA1);	//设置左右方向，0xA1正常 0xA0左右反置
	
	OLED_WriteCommand(0xC8);	//设置上下方向，0xC8正常 0xC0上下反置


	OLED_WriteCommand(0xDA);	//设置COM引脚硬件配置
	OLED_WriteCommand(0x12);
	
	OLED_WriteCommand(0x81);	//设置对比度控制
	OLED_WriteCommand(0xff);

	OLED_WriteCommand(0xD9);	//设置预充电周期
	OLED_WriteCommand(0xF1);

	OLED_WriteCommand(0xDB);	//设置VCOMH取消选择级别
	OLED_WriteCommand(0x30);

	OLED_WriteCommand(0xA4);	//设置整个显示打开/关闭

	OLED_WriteCommand(0xA6);	//设置正常/倒转显示

	OLED_WriteCommand(0x8D);	//设置充电泵
	OLED_WriteCommand(0x14);

	OLED_WriteCommand(0xAF);	//开启显示
		
	OLED_Clear();				//OLED清屏
}

//区域填充(x1,y2)(x2,y2)左上->右下(坐标)
void AreaFill(unsigned char y1, unsigned char x1,unsigned char y2, unsigned char x2)
{
	short i,j;
	short dx;
	dx=x2-x1;
	for(i=y1;i<y2;i++)
	{
		OLED_SetCursor(i,x1);
		for(j=0;j<dx;j++)//竖直方向填充
			OLED_WriteData(0x00);//上到下
	}
}
//F6x8[str-'']
//针对目前代码 oled像素位置
//两条竖线(x1,y2)(x2,y2)左上->右下(坐标)
void huakuang(unsigned char y1, unsigned char x1,unsigned char y2, unsigned char x2)
{
	char i;
	for(i=y1;i<y2;i++)
	{OLED_SetCursor(i,x1);
		OLED_WriteData(0xff);}
	for(i=y1;i<y2;i++)
	{OLED_SetCursor(i,x2);
		OLED_WriteData(0xff);}
}

char bufdis[6*98];//申明显存（需要使用的是：(1,27)(7,127)矩形 ）
//上下两边跨 缓存区
void bufdiskuan(void)
{
	unsigned char x;
	for(x=0;x<97;x++)
	{
		bufdis[x]|=1;
		bufdis[x+490]|=0x80;
	}
}
//水平虚线
void Placedashed_line(char y)
{
	unsigned char x,i;
	y=limit(y,0,47);
	for(x=0;x<97;x++)
	{
		i++;
		if(i>4)
		{bufdis[x+(y/8)*98]|=1<<(y%8);}
		if(i==8)
			i=0;
	}
}
//竖直虚线
void PlaceVerticalline(char x)
{
	unsigned char i;
	x=limit(x,0,97);
	for(i=0;i<6;i++)
		bufdis[x+i*98]|=0xf0;
}
//缓存归零
void Clearbuffer(void)
{
	long i=0,k=6*100;
	for(;i<k;i++)
		bufdis[i]=0;
}
//显示缓存区域
void OLED_Display(unsigned char y1, unsigned char x1,unsigned char y2, unsigned char x2)
{
    unsigned char i, j;
	unsigned char k=x2-x1;//126-28
	//bufdiskuan();//画框
    for(i=y1;i<y2;i++)
	{
		OLED_SetCursor(i,x1);
		for(j=x1;j<x2;j++)
			OLED_WriteData(bufdis[k*(i-y1)+j-x1]);
	}
}
//画点到缓存
void PlacePixel(unsigned char y, unsigned char x)
{
	y=limit(y,0,47); //youxia-zuoshang
	x=limit(x,0,97);
	bufdis[x+(y/8)*98]&=~(1<<(y%8));
    bufdis[x+(y/8)*98]|=1<<(y%8);
}
void PlacePixel_black(unsigned char y, unsigned char x)//画黑点
{
	y=limit(y,0,47); //youxia-zuoshang
	x=limit(x,0,97);
	bufdis[x+(y/8)*98]&=~(1<<(y%8));
}
//写字节
void Placecharbit(unsigned char x, unsigned char y,unsigned char cha)
{
	unsigned char i=0;
	for(;i<8;i++)
	{
		if(cha&(1<<i))
			PlacePixel((unsigned char)(x+i),y);
		else
			PlacePixel_black((unsigned char)(x+i),y);
	}
}
//写字符
void Placechar(unsigned char x, unsigned char y,unsigned char chr)
{
	unsigned char c=0,i=0;
    c=chr-' ';
	//OLED_SetCursor(x,y);
	for(i=0;i<6;i++)
	Placecharbit(x,(unsigned char)(y+i),F6x8[c][i]);
}
void Placechar_black(unsigned char x, unsigned char y,unsigned char chr)
{
	unsigned char c=0,i=0;
    c=chr-' ';
	//OLED_SetCursor(x,y);
	for(i=0;i<6;i++)
	Placecharbit(x,(unsigned char)(y+i),~F6x8[c][i]);
}
//写字符串
void PlaceString(unsigned char Line, unsigned char Column, char *String)
{
	unsigned char i;
	for (i = 0; String[i] != '\0'; i++)
	{
		Placechar((unsigned char)(Line-1), (unsigned char)(Column-1 + i*6), String[i]);
	}
}
void PlaceString_black(unsigned char Line, unsigned char Column, char *String)
{
	unsigned char i;
	for (i = 0; String[i] != '\0'; i++)
	{
		Placechar_black((unsigned char)(Line-1), (unsigned char)(Column-1 + i*6), String[i]);
	}
}
//格式化缓存
void printf_Place(char a,char b,char *stringg, ...)
{
	char stringx[100];  //一个足够长的字符串
	va_list arg;
	va_start(arg,stringg);
	vsprintf(stringx,stringg,arg);
	va_end(arg);
	PlaceString(a,b,stringx); //发送函数 可以是oled usart spi 。。。。字符串格式
}
//格式化缓存
void printf_Place_black(char a,char b,char *stringg, ...)
{
	char stringx[100];  //一个足够长的字符串
	va_list arg;
	va_start(arg,stringg);
	vsprintf(stringx,stringg,arg);
	va_end(arg);
	PlaceString_black(a,b,stringx); //发送函数 可以是oled usart spi 。。。。字符串格式
}
#include "math.h"
//起点终点 使用的算法：bresenham 画直线
void Placeline(unsigned char y1, unsigned char x1,unsigned char y2, unsigned char  x2)
{
	float dx=abs(x2-x1), dy=abs(y2-y1),swap,b;//b斜率
	float err;//跟踪斜率 调整ystep
	y1=limit(y1,0,47);x1=limit(x1,0,97);
	y2=limit(y2,0,47);x2=limit(x2,0,97);
	dx=abs(x2-x1); 
	dy=abs(y2-y1);
	//整型运算速度更高
	if((y1>y2)&&(x1>x2))//点位交换 向左上 -> 向右下
	{swap=y1;y1=y2;y2=swap;
		swap=x1;x1=x2;x2=swap;
		if(dy>dx)
		{	b=dx/dy;
			err=x1;
			while(y1<=y2)
			{PlacePixel(y1, x1);y1++;err+=b;
				if( (x1+0.5-err)<0 )
				{x1++;}}}
		else
		{	b=dy/dx;
			err=y1;
			while(x1<=x2)
			{PlacePixel(y1, x1);x1++;err+=b;
				if( (y1+0.5-err)<0 )
				{y1++;}}}}
	else if((y1<y2)&&(x1>x2))//点位交换 向左下 -> 向右上
	{swap=y1;y1=y2;y2=swap;
		swap=x1;x1=x2;x2=swap;
		if(dy>dx)
		{	b=dx/dy;
			err=x1;
			while(y2<=y1)
			{PlacePixel(y2, x1);y2++;err-=b;
				if( (x1-0.5-err)>0 )
				{x1--;}}}
		else
		{	b=dy/dx;
			err=y1;
			while(x1<=x2)
			{PlacePixel(y1, x1);x1++;err-=b;
				if( (y1-0.5-err)>0 )
				{y1--;}}}}
	else if((y1>y2)&&(x1<x2))//向右上
	{if(dy>dx)
		{	b=dx/dy;
			err=x1;
			while(y2<=y1)
			{PlacePixel(y2, x1);y2++;err-=b;
				if( (x1-0.5-err)>0 )
				{x1--;}}}
		else
		{	b=dy/dx;
			err=y1;
			while(x1<=x2)
			{PlacePixel(y1, x1);x1++;err-=b;
				if( (y1-0.5-err)>0 )
				{y1--;}}}}
	else//向右下
	{if(dy>dx)
		{	b=dx/dy;
			err=x1;
			while(y1<=y2)
			{PlacePixel(y1, x1);y1++;err+=b;
				if( (x1+0.5-err)<0 )
				{x1++;}}}
		else
		{	b=dy/dx;
			err=y1;
			while(x1<=x2)
			{PlacePixel(y1, x1);x1++;err+=b;
				if( (y1+0.5-err)<0 )
				{y1++;}}}}
}
//画圆
void PlaceCyuan(unsigned char y1, unsigned char x1,unsigned char R)
{
	float err,r=R*R,b;//,dx,dy
	unsigned char x=x1,y=y1;
	float p=x+x,k=y+y,d=x+y,e=y-x,f=x-y,g=2*x,h=x*x,j=(y-0.5)*(y-0.5),q=2*(y-0.5);
	y1=limit(y1,0,47);
	x1=limit(x1,0,97);
	b=x1+R/1.414;
	y1-=R;
    while(x1<b)
	{
		PlacePixel( y1, x1);
		PlacePixel( y1,(unsigned char)(-x1+p));
		PlacePixel((unsigned char)(-y1+k), x1);
		PlacePixel((unsigned char)(-y1+k),(unsigned char)(-x1+p));
		PlacePixel((unsigned char)( x1+e),(unsigned char)( y1+f));
		PlacePixel((unsigned char)( x1+e),(unsigned char)(-y1+d));
		PlacePixel((unsigned char)(-x1+d),(unsigned char)( y1+f));
		PlacePixel((unsigned char)(-x1+d),(unsigned char)(-y1+d));//圆的8个部分
		x1++;
		err = x1*x1-g*x1+h + j-q*y1+y1*y1 - r;
        if ( err>0 )
            y1+=1;
    }
}
//绘制波形
//plot 1点图 0折线图    tongdao 通道选择：0-A0 1-A1 2-A2 3-A3 
//pianyi 扫描数据位置偏移 可偏移的范围： 0-302 (时间轴) 大数接近现在，小数接近以前
//chufa 触发电平： 若
/*
float ADbuf[500];								//另存AD值  在 oled.h 中重申明
unsigned short vMax =0 , vMin=0; 					// 最值
float dacMin,dacMax;								//得出波形的电压最值
extern short jiaozun0,jiaozun1,jiaozun2,jiaozun3;	//通道零位校准
unsigned char Vzuidaliangchen;				//电压最大量程挡位  //间隔为1v  是±50之间的0-50的值
char xianshimax,xianshimin;						//显示的上下限
short chufaweizhi;									//触发位置
float STVX; //中间变量 用于转接校准电压  手动给值
// 点图 ,通道,水平偏移,触发电平,触发边沿,数据更新,时间
void PlotWave(char plot,char tongdao,short shijianpianyi,short chufa,char chufabianyan,char gengxin, short shijian )
{//AD_Value中的数据是 4个引脚电压为一组 A0 A1 A2 A3  A0 A1 A2 A3......
    //Vector Mode 折线
	unsigned short i,a;
	float tmp ; //中间值
	char ok = 1 ;
	dacMax = -50 ;
    dacMin = 50 ;
	switch ( tongdao ) 
	{
		case 0 :{ STVX=1462; } break ;  //jiaozun0
		case 1 :{ STVX=1459; } break ;  //jiaozun1
		case 2 :{ STVX=1461; } break ;  //jiaozun2
		case 3 :{ STVX=1462; } break ;  //jiaozun3
	}
	if ( gengxin )
	{
		TIM_Cmd(TIM3, ENABLE); // DISABLE ENABLE 可用于控制AD转换触发使能
		for(i=0;i<DATnum-98;i++)
		{
			ADbuf [ i ] = (float)( (short)AD_Value[ i * 4 + tongdao ] - STVX ) * 0.033;//0.0330322265625
			tmp = ADbuf [ i ];
			// ( AD_Value / 4096 * 3.3 ) * ( 5 / 205 )   单位:V
			//其中:5/205是分压电阻的分压比
			if ( tmp > dacMax )
				dacMax = tmp;
			else if ( tmp < dacMin )
				dacMin = tmp;
			//求出数据的最大幅度
		} //数据处理
	}
	
	a=49; //防止数组溢出
	if(chufabianyan) //触发边沿选择：上升沿触发
		while(!((ADbuf[a]<chufa)&&(chufa<ADbuf[a+1]))) //判断数值边沿
		{a++;if(a>DATnum-98){ok=0;break;}}
	else //下降沿触发
		while(!((ADbuf[a]>chufa)&&(chufa>ADbuf[a+1])))
		{a++;if(a>DATnum-98){ok=0;break;}}
	a-=49; //偏移到屏幕中间
	//记录a值:a值就是触发数组的位置（时间）
	shijianpianyi=limit(shijianpianyi,-a,DATnum-98+a);
	if( chufa ) //登记触发情况
	{ if ( ok )	printf_oled_mini ( 1,42,"%d:YT",tongdao ) ;
		else	printf_oled_mini ( 1,42,"%d:NT",tongdao ) ; }
	
	
	
//	Placedashed_line(dacMax);//画出波形最值位置的虚线
//	Placedashed_line(dacMax);
	
//	xianshimax= (short)Vzuidaliangchen * bgADC * 100 / (*BGV) / Lsb ;
//	xianshimin= - xianshimax ;
	
	
    if ( plot == 0 )
    {
        for (i=0; i < 98; i++)//98是画框长度
        {//86是使4096刚好在画框宽度范围内
            Placeline ( 24+ADbuf [ ( i+shijianpianyi ) ] *2 , i ,  24+ADbuf[(i+1+shijianpianyi)] *2 ,i+1 ) ;
        }
    }
    //Dots Mode 点图
    if ( plot == 1 )
    {
        for ( i = 0 ; i <= 98 ; i++ )
        {
            PlacePixel(  24+ADbuf[(i+shijianpianyi)]*2  , i);
        }
    }
}
*/



